# Generated automatically from Makefile.in by configure.
#
# This file is a Makefile for Wrap.  If it has the name "Makefile.in"
# then it is a template for a Makefile;  to generate the actual Makefile,
# run "./configure", which is a configuration script generated by the
# "autoconf" program (constructs like "@foo@" will get replaced in the
# actual Makefile.

EXTENSION	=	Wrap
VERSION 	=	0.3
TCL_VERSION	=	8.2
TCLVERSION	=	82

CYGWIN_FLAGS	=	
DLL_FLAGS	=	# -DUSE_TCL_STUBS -DUSE_TK_STUBS   # uncomment this if you want a dll

WRAP_LIB_FILE	=	libwraps.a
WRAP_LIB_LIB	=	libwrap.a
WRAP_LIB_DLL	=	wrap03.dll

GENERICDIR	= ../tcl8.2.1/generic
WINDIR		= ../tk8.2.1/win
WINRCDIR	= ../tk8.2.1/win/rc

# Directory where libz and libcrypt are at runtime.
WRAP_RUNTIME_DIR	=	$(prefix)/lib

# How to reference the libz library.
ZREF		= -L${WRAP_RUNTIME_DIR} -L. -lzs
#ZREF		= -liflPNG		# this works for Irix 6.2

# How to reference the crypt library.
CRYPTREF	= -L${WRAP_RUNTIME_DIR} -L. -lcrypts

#name of the binary distribution file.
WRAP_BIN_DIST_FILE	=	wrap$(VERSION).system.tar

#
# If you want the dynamicall loader to load
# the libraries always from the same directory,
# do it here. Warning: the tests only work
# if the libaries really are there!!!!
#

WRAP_FULL_PATH	=
#WRAP_FULL_PATH	=	<full-path>/wrap$(VERSION)/ # don't forget the final slash!!

#
# names of additional libraries to be used/produced.
#

Z_LIB_DLL	=	zlib.dll
Z_LIB_LIB	=	libz.a
Z_LIB_SLIB	=	libzs.a
Z_LIB_DEF	=	zlib.def

CRYPT_LIB_DLL	=	crypt.dll
CRYPT_LIB_LIB	=	libcrypt.a
CRYPT_LIB_SLIB	=	libcrypts.a
CRYPT_LIB_DEF	=	crypt.def

#
# If your system has an option to specify the library-name
# at runtime (such as -soname or -h), uncomment the following

WRAP_HNAME	= #-Wl,-soname,${WRAP_LIB_FILE}
Z_HNAME		= #-Wl,-soname,libz.so.1
CRYPT_HNAME	= #-Wl,-soname,libcrypt.so.2

#
#----------------------------------------------------------------
# Things you can change to personalize the Makefile for your own
# site (you can make these changes in either Makefile.in or
# Makefile, but changes to Makefile will get lost if you re-run
# the configuration script).
#----------------------------------------------------------------

# Default top-level directories in which to install architecture-
# specific files (exec_prefix) and machine-independent files such
# as scripts (prefix).  The values specified here may be overridden
# at configure-time with the --exec-prefix and --prefix options
# to the "configure" script.

prefix		=	/progra~1/tcl
exec_prefix	=	/progra~1/tcl

# Directory in which the source of this extension can be found
srcdir		=	.

# Directories in which the Tcl core can be found
TCL_INC_DIR		=	${prefix}/include
TCL_LIB_DIR		=	${prefix}/tcl/lib
TCL_LIB_SPEC		=	-L${TCL_LIB_DIR} -ltcl82s${DBGX}

# Directories in which the Tk core can be found
TK_LIB_SPEC		=	-L${TCL_LIB_DIR} -ltk82s${DBGX}

# Libraries to be included with libwrap$(VERSION).so
TCL_SHARED_LIBS		=	

# The following definition can be set to non-null for special systems
# like AFS with replication.  It allows the pathnames used for installation
# to be different than those used for actually reference files at
# run-time.  INSTALL_ROOT is prepended to $prefix and $exec_prefix
# when installing files.
INSTALL_ROOT =


# Directory where libwrap.a is at run-time:
LIB_RUNTIME_DIR =	$(exec_prefix)/lib/$(EXTENSION)$(VERSION)


# Directory in which to install the archive libwrap.a:
LIB_INSTALL_DIR =	$(INSTALL_ROOT)$(LIB_RUNTIME_DIR)


# Directory in which to install the extended shell tclsh:
BIN_INSTALL_DIR =	$(INSTALL_ROOT)$(exec_prefix)/bin


# Directory in which to install the include file transform.h:
INCLUDE_INSTALL_DIR =	$(INSTALL_ROOT)$(prefix)/include


# Top-level directory in which to install manual entries:
MAN_INSTALL_DIR =	$(INSTALL_ROOT)$(prefix)/man

# Directory where libz, libpng and libjpeg are (or will be) installed.
WRAP_INSTALL_DIR	=	$(INSTALL_ROOT)$(WRAP_RUNTIME_DIR)

# To change the compiler switches, for example to change from -O
# to -g, change the following line:
CFLAGS		=	-O2 -mno-cygwin -fnative-struct -DHAVE_MEMCPY -DSTATIC_BUILD

# To disable ANSI-C procedure prototypes reverse the comment characters
# on the following lines:
PROTO_FLAGS =
#PROTO_FLAGS = -DNO_PROTOTYPE


# To enable memory debugging reverse the comment characters on the following
# lines.  Warning:  if you enable memory debugging, you must do it
# *everywhere*, including all the code that calls Tcl, and you must use
# ckalloc and ckfree everywhere instead of malloc and free.
MEM_DEBUG_FLAGS =
#MEM_DEBUG_FLAGS = -DTCL_MEM_DEBUG


# Some versions of make, like SGI's, use the following variable to
# determine which shell to use for executing commands:
SHELL =		/bin/sh


# Tcl used to let the configure script choose which program to use
# for installing, but there are just too many different versions of
# "install" around;  better to use the install-sh script that comes
# with the distribution, which is slower but guaranteed to work.

INSTALL = $(tool)/install-sh -c
AR = ar
AS = as
LD = ld
UPX = : upx --best        # remove the ':' if you want to use upx
DLLTOOL = dlltool
WINDRES = windres
DLLWRAP = dllwrap -mno-cygwin

DLL_LDFLAGS = -mwindows -Wl,-e,_DllMain@12 -mno-cygwin
DLL_LDLIBS = -L/progra~1/tcl/lib -ltclstub82

conlflags = -Wl,--subsystem,console -mwindows
guilflags = -mwindows

baselibs   = -lkernel32 $(optlibs) -ladvapi32 -luser32
winlibs    = $(baselibs) -lgdi32 -lcomdlg32 -lwinspool

# The symbols below provide support for dynamic loading and shared
# libraries.  The values of the symbols are normally set by the
# configure script.  You shouldn't normally need to modify any of
# these definitions by hand.

WRAP_SHLIB_CFLAGS = -D_MT -D__WIN32__

# Libraries to use when linking:  must include at least the dynamic
# loading library and the math library (in that order).  This
# definition is determined by the configure script.
ALL_LIBS =  $(TCL_LIB) -ldl -lm

LIBS =  -lm -lc

#----------------------------------------------------------------
# The information below is modified by the configure script when
# Makefile is generated from Makefile.in.  You shouldn't normally
# modify any of this stuff by hand.
#----------------------------------------------------------------

INSTALL_PROGRAM =	$(INSTALL) -m 744
INSTALL_DATA =		$(INSTALL) -m 644
INSTALL_SHLIB =		$(INSTALL) -m 555
RANLIB =		:
SHLIB_SUFFIX =		.so

#----------------------------------------------------------------

zlibdir		=	$(srcdir)/libz
cryptdir	=	$(srcdir)/md5-crypt

#----------------------------------------------------------------
# The information below should be usable as is.  The configure
# script won't modify it and you shouldn't need to modify it
# either.
#----------------------------------------------------------------

CC		=	gcc

# $(TCL_CC_SWITCHES)
INCLUDES	=	-I. -I$(srcdir) -I$(zlibdir) -I$(cryptdir) -I$(TCL_INC_DIR)
DEFINES		=	$(PROTO_FLAGS) $(MEM_DEBUG_FLAGS) $(WRAP_SHLIB_CFLAGS)
CC_SWITCHES	=	$(CFLAGS) $(DEFINES) $(INCLUDES) -DWRAP_VERSION=\"$(VERSION)\"	\
			-DZ_LIB_NAME=\"$(WRAP_FULL_PATH)$(Z_LIB_DLL)\" \
			-DCRYPT_LIB_NAME=\"$(WRAP_FULL_PATH)$(CRYPT_LIB_DLL)\" \
			-Ddlopen=wrapDlopen -Ddlclose=wrapDlclose -Ddlsym=wrapDlsym -Ddlerror=wrapDlerror

#		fundamentals of this library
SOURCES	=	wrapChan.c wrapInit.c wrapRsrc.c wrapMain.c
OBJECTS	=	wrapChan.o wrapInit.o wrapRsrc.o wrapMain.o 

#-------------------------------------------------------#

default:	$(WRAP_LIB_FILE) tclsh${TCLVERSION}s.exe wish${TCLVERSION}s.exe

all:	$(Z_LIB_FILE) $(WRAP_LIB_FILE)

tclsh${TCLVERSION}s.exe:	$(WRAP_LIB_FILE) tclAppInit.o tclres.o
	$(CC) -mno-cygwin -o $@ tclAppInit.o ${conlflags} tclres.o\
		${WRAP_LIB_FILE} $(TCL_LIB_SPEC) ${ZREF} ${CRYPTREF} ${baselibs}
	strip $@
	$(UPX) $@
	cat null.zip >>$@
	zip -A -9 $@ tcl*.tcl
	cp library/* lib/wrap$(VERSION)
	zip -A -r -9 $@ lib/wrap$(VERSION) lib/tcl$(TCL_VERSION)

wish${TCLVERSION}s.exe:	$(WRAP_LIB_FILE) tkAppInit.o tkres.o
	$(CC) -mno-cygwin -o $@ tkAppInit.o ${guilflags} tkres.o \
		${WRAP_LIB_FILE} $(TK_LIB_SPEC) $(TCL_LIB_SPEC) \
		${ZREF} ${CRYPTREF} ${winlibs}
	strip $@
	$(UPX) $@
	cat null.zip >>$@
	zip -A -9 $@ tcl*.tcl wish*.tcl tkcon.tcl
	cp library/* lib/wrap$(VERSION)
	zip -A -r -9 $@ lib/wrap$(VERSION) lib/tcl$(TCL_VERSION) lib/tk$(TCL_VERSION)

install-all:	install install-z install-crypt

install: $(WRAP_LIB_FILE)
	@$(tool)/mkinstalldirs $(LIB_INSTALL_DIR)
	@echo "Installing $(WRAP_LIB_FILE)"
	@$(INSTALL_SHLIB) $(WRAP_LIB_FILE) $(LIB_INSTALL_DIR)
	@$(RANLIB) $(LIB_INSTALL_DIR)/$(WRAP_LIB_FILE)
	@echo "Installing pkgIndex.tcl"
	@$(INSTALL_DATA) $(srcdir)/pkgIndex.tcl $(LIB_INSTALL_DIR)

install-z:	$(Z_LIB_FILE)
	@$(tool)/mkinstalldirs $(WRAP_INSTALL_DIR) $(INCLUDE_INSTALL_DIR)
	@echo "Installing $(Z_LIB_FILE)"
	@$(INSTALL_SHLIB) $(Z_LIB_FILE) $(WRAP_INSTALL_DIR)
	@$(RANLIB) $(WRAP_INSTALL_DIR)/$(Z_LIB_FILE)
	@for i in zlib.h zconf.h; do \
	    echo "Installing $$i"; \
	    $(INSTALL_DATA) $(zlibdir)/$$i $(INCLUDE_INSTALL_DIR); \
	done;

install-crypt:	$(CRYPT_LIB_FILE)
	@$(tool)/mkinstalldirs $(WRAP_INSTALL_DIR) $(INCLUDE_INSTALL_DIR)
	@echo "Installing $(CRYPT_LIB_FILE)"
	@$(INSTALL_SHLIB) $(CRYPT_LIB_FILE) $(WRAP_INSTALL_DIR)
	@$(RANLIB) $(WRAP_INSTALL_DIR)/$(CRYPT_LIB_FILE)

bindist:
	rm -rf wrap$(VERSION)
	$(tool)/mkinstalldirs wrap$(VERSION)
	cp README* wrap$(VERSION)
	cp demo.tcl wrap$(VERSION)
	cp $(WRAP_LIB_FILE) wrap$(VERSION)
	cp pkgIndex.tcl wrap$(VERSION)
	if test -f $(Z_LIB_FILE); then \
	    cp $(Z_LIB_FILE) wrap$(VERSION); \
	    cp $(zlibdir)/zlib.h wrap$(VERSION); \
	    cp $(zlibdir)/zconf.h wrap$(VERSION); \
	fi
	tar cf $(WRAP_BIN_DIST_FILE) wrap$(VERSION)
	rm -f $(WRAP_BIN_DIST_FILE).gz
	gzip -9 $(WRAP_BIN_DIST_FILE)
	rm -rf wrap$(VERSION)

#-------------------------------------------------------#

.c.o:
	$(CC) -c $(CC_SWITCHES) $(DLL_FLAGS) $< -o $@

wrapres.o: $(srcdir)/wrap.rc
	$(WINDRES) --include $(GENERICDIR) --include $(WINDIR) \
	  --define __WIN32__ --define VS_VERSION_INFO=1 \
	  wrap.rc wrapres.o

tclres.o: $(srcdir)/tclshs.rc
	$(WINDRES) --include $(GENERICDIR) --include $(WINDIR) \
	  --define __WIN32__ --define VS_VERSION_INFO=1 \
	  tclshs.rc tclres.o

tkres.o: $(srcdir)/wishs.rc
	$(WINDRES) --include $(GENERICDIR) --include $(WINDIR) --include $(WINRCDIR) \
	  --define __WIN32__ --define VS_VERSION_INFO=1 \
	  wishs.rc tkres.o

#-------------------------------------------------------#

$(WRAP_LIB_FILE):	$(OBJECTS) compat/tclLoadNone.o 
	ar cr $@ ${OBJECTS} compat/tclLoadNone.o 

$(WRAP_LIB_DLL):	$(OBJECTS) compat/dllEntry.o compat/tclLoadWin.o wrapres.o 
	echo EXPORTS > wrap.def
	echo Wrap_Init >> wrap.def
	$(DLLWRAP) -s $(DLL_LDFLAGS) -o $@ \
	  --def wrap.def $(OBJECTS) compat/dllEntry.o compat/tclLoadWin.o wrapres.o \
	  $(DLL_LDLIBS)
	rm -rf wrap.def

#-------------------------------------------------------#
# support for external libraries (libz)


ZLIB_SRC	=	\
	$(zlibdir)/adler32.c	$(zlibdir)/compress.c	$(zlibdir)/crc32.c	\
	$(zlibdir)/deflate.c	$(zlibdir)/gzio.c	$(zlibdir)/infblock.c	\
	$(zlibdir)/infcodes.c	$(zlibdir)/inffast.c	$(zlibdir)/inflate.c	\
	$(zlibdir)/inftrees.c	$(zlibdir)/infutil.c	$(zlibdir)/trees.c	\
	$(zlibdir)/uncompr.c	$(zlibdir)/zutil.c	compat/dllEntry.c

ZLIB_OBJ	=	\
	$(zlibdir)/adler32.o	$(zlibdir)/compress.o	$(zlibdir)/crc32.o	\
	$(zlibdir)/deflate.o	$(zlibdir)/gzio.o	$(zlibdir)/infblock.o	\
	$(zlibdir)/infcodes.o	$(zlibdir)/inffast.o	$(zlibdir)/inflate.o	\
	$(zlibdir)/inftrees.o	$(zlibdir)/infutil.o	$(zlibdir)/trees.o	\
	$(zlibdir)/uncompr.o	$(zlibdir)/zutil.o	compat/dllEntry.o


z:	$(Z_LIB_DLL) $(Z_LIB_LIB) $(Z_LIB_SLIB)
	@echo ... done

$(Z_LIB_DLL):	$(ZLIB_OBJ) $(Z_LIB_DEF)
	$(DLLWRAP) -s $(DLL_LDFLAGS) -o $(Z_LIB_DLL) \
	    --def zlib.def $(ZLIB_OBJ)

$(Z_LIB_DEF):	$(ZLIB_OBJ)
	$(DLLTOOL) --export-all --exclude-symbols DllMain@12 \
		--add-stdcall-alias --output-def $@ $(ZLIB_OBJ)

$(Z_LIB_LIB):	$(ZLIB_OBJ) $(Z_LIB_DEF)
	$(DLLTOOL) --as=$(AS) --dllname $(Z_LIB_DLL) \
	  --def $(Z_LIB_DEF) --output-lib $(Z_LIB_LIB)

$(Z_LIB_SLIB):	$(ZLIB_OBJ)
	$(AR) cr $(Z_LIB_SLIB) $(ZLIB_OBJ)


#-------------------------------------------------------#
# support for external libraries (crypt)


CRYPT_SRC	=	\
	$(cryptdir)/md5.c	$(cryptdir)/md5-crypt.c	$(cryptdir)/crypt-entry.c \
	$(cryptdir)/stpncpy.c	compat/dllEntry.c

CRYPT_OBJ	=	\
	$(cryptdir)/md5.o	$(cryptdir)/md5-crypt.o	$(cryptdir)/crypt-entry.o \
	$(cryptdir)/stpncpy.o	compat/dllEntry.o


crypt:	$(CRYPT_LIB_SLIB) md5test.exe md5c-test.exe
	@./md5test.exe
	@./md5c-test.exe
	@echo ... done

md5test.exe:	$(CRYPT_LIB_DLL) $(CRYPT_LIB_LIB) $(cryptdir)/md5test.o
	$(CC) -o $@ $(CC_SWITCHES) $(DLL_FLAGS) $(cryptdir)/md5test.o -L. -lcrypt

md5c-test.exe:	$(CRYPT_LIB_DLL) $(CRYPT_LIB_LIB) $(cryptdir)/md5c-test.o
	$(CC) -o $@ $(CC_SWITCHES) $(DLL_FLAGS) $(cryptdir)/md5c-test.o -L. -lcrypt

$(CRYPT_LIB_DLL):	$(CRYPT_OBJ) $(CRYPT_LIB_DEF)
	$(DLLWRAP) -s $(DLL_LDFLAGS) -o $(CRYPT_LIB_DLL) \
	    --def crypt.def $(CRYPT_OBJ)

$(CRYPT_LIB_DEF):	$(CRYPT_OBJ)
	$(DLLTOOL) --export-all --exclude-symbols DllMain@12 \
		--add-stdcall-alias --output-def $@ $(CRYPT_OBJ)

$(CRYPT_LIB_LIB):	$(CRYPT_OBJ) $(CRYPT_LIB_DEF)
	$(DLLTOOL) --as=$(AS) --dllname $(CRYPT_LIB_DLL) \
	  --def $(CRYPT_LIB_DEF) --output-lib $(CRYPT_LIB_LIB)

$(CRYPT_LIB_SLIB):	$(CRYPT_OBJ)
	$(AR) cr $(CRYPT_LIB_SLIB) $(CRYPT_OBJ)


#-------------------------------------------------------#

clean:
	rm -f $(OBJECTS) $(WRAP_LIB_FILE)
	rm -f $(ZLIB_OBJ) $(Z_LIB_FILE)
	rm -f $(CRYPT_OBJ) $(CRYPT_LIB_FILE)
	rm -f TAGS depend *~ */*~ core* tests/core* so_locations lib*.so*
	rm -f tclsh8.2s.exe wish8.2s.exe tclAppInit.o tkAppInit.o
	rm -rf wrap$(VERSION)

distclean:	clean
	rm -f config.* Makefile pkgIndex.tcl

#-------------------------------------------------------#
# DO NOT DELETE THIS LINE -- make depend depends on it.
