#!/bin/sh
#\
exec wish8.2 $0 ${1+"$@"}

package require Tk

#
# TkCon
#

proc start_tkcon {} {
  set loaded [info loaded {}]
  uplevel #0 ::wrap::source tkcon.tcl

  # Make all packages available to the slave as well
  foreach pkg $loaded {
    set name [lindex $pkg 1]
    set version [package require $name]
    slave eval package require $name $version
    unset name version
  }
  .mbar.file add command -label Install -command [list start_installer .inst]
}

#
# installer window
#

proc start_installer w {
    global tcl_platform
    if {![winfo exists $w]} {
	toplevel $w
	wm title $w
    }
    if {![string compare $w .]} {
	set w {}
    }
    label $w.l -text {Where do you want to install this file?}
    entry $w.e
    if {![string compare $tcl_platform(platform) windows]} {
	set dir \\progra~1\\tcl\\bin\\wish82s.exe
    } elseif {![string compare $tcl_platform(os) Linux]} {
	set dir /usr/bin/wish8.2s
    } else {
	set dir /usr/local/bin/wish8.2s
    }
    $w.e insert end $dir
    button $w.b -text Search -command [list select $w.e]
    button $w.ok -text OK -command [list install $w.e]
    pack $w.l
    pack $w.e -side left
    pack $w.b -side right
    pack $w.ok -side bottom

    proc select w {
	set entry [$w get]
	set dir [file dirname $entry]
	set tail [file tail $entry]
	set result [tk_getSaveFile -initialdir $dir -initialfile $tail]
	if {[string compare $result {}]} {
	    $w delete 0 end
	    $w insert end $result
	}
    }

    proc install w {
	set result [$w get]
	file copy [info nameofexecutable] $result
	tk_messageBox -title "Installation completed" \
		-message "File is installed as $result" \
		-type ok
    }
}

if {[file exists [lindex $argv 0]]} {
    set argv0 [lindex $argv 0]
    set argv [lrange $argv 1 end]
    incr argc -1
    source $argv0
} else {
    if [catch start_tkcon msg] {
	tk_messageBox -title "Error in TkCon:" \
		-message "$msg $errorInfo" \
		-type ok
    }
}
