/*
 * wrap.h --
 *
 *	This header file describes the externally-visible facilities
 *	of the Wrap package.
 *
 * Copyright (c) 1999   Jan Nijtmans
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef _WRAP
#define _WRAP

#define WRAP_MAJOR_VERSION   0
#define WRAP_MINOR_VERSION   3
#define WRAP_RELEASE_LEVEL   0
#define WRAP_RELEASE_SERIAL  0

#define WRAP_VERSION	    "0.3"
#define WRAP_PATCH_LEVEL    "0.3"

/* 
 * A special definition used to allow this header file to be included 
 * in resource files so that they can get obtain version information from
 * this file.  Resource compilers don't like all the C stuff, like typedefs
 * and procedure declarations, that occur below.
 */

#ifndef RESOURCE_INCLUDED

#include "tcl.h"

EXTERN Tcl_Channel Wrap_Open _ANSI_ARGS_((Tcl_Interp *, Tcl_Obj *, CONST char *));
EXTERN int	   Wrap_Files _ANSI_ARGS_((Tcl_Interp *, Tcl_Obj *));

EXTERN int	   Wrap_Init _ANSI_ARGS_((Tcl_Interp *));
EXTERN void	   Wrap_Main _ANSI_ARGS_((int, char **, Tcl_AppInitProc *, Tcl_Interp *));

#endif /* RESOURCE_INCLUDED */

#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLIMPORT

#endif /* _TCL */
